//
// PovRay scene file for a town hall
//
// Author:   Hj. Malthaner
// Email:    hansjoerg.malthaner@gmx.de
// Date:     2012/07/06
//
// Web:      http://opengameart.org/users/varkalandar
//
// This file is available under the GNU general
// public license v2 or newer.
//
// http://www.gnu.org/licenses/gpl-2.0.html
//

global_settings 
{
	assumed_gamma 2.2
  max_trace_level 240
}

light_source
{
	<-15, 17, -9>
	color rgb 1
}

camera 
{
  orthographic 
	location <0, 0, -7.1>
  rotate <30, 0, 0>
  rotate <0, 45, 0>
	look_at <0, 0, 0>
  translate <0, 1, 0>
}

#declare TEX_BASE =
texture
{
  pigment 
  {
    color rgb <0.59, 0.57, 0.55>
		quick_color 1
  }
  normal
  {
    granite 0.03
    scale 0.005
  }
  finish
  {
    ambient 0.1
    diffuse 0.35
    specular 0.05
    roughness 0.2
  }
}


// Floor
box 
{
	<-60, -1, -60>,
	<60, 0, 60>
	
	texture 
	{
  
		pigment 
		{
      color rgb 0.3
      
			quick_color 0

			rotate <90, 0, 0>
			scale 15
			translate <-7, 0, -7>
			scale 2
			rotate <0, 45, 0>
		}

		finish 
		{
			ambient 0.4
			diffuse 0.6
			specular 0.10
			roughness 1/120
		}
	}
  
  translate <0, -0.2, 0>
}

// sky
sphere
{
	0, 200

	texture 
	{
		pigment 
		{
			bozo
			color_map
			{
				[0.1 color rgb <0.8, 0.7, 1>]
				[0.9 color rgb <0.8, 0.7, 1>]
			}
			quick_color 0
			
			scale 0.01
		}
		normal
		{
			bozo 0.05
			scale 0.01
		}
		finish
		{
			ambient 0.04
			diffuse 0.3
			specular 0.3
			roughness 0.05
			reflection 0.05
		}    
	}
	hollow
}

#declare TEX_GLASS =
texture
{
  pigment 
  {
    color rgbf <0.94, 0.92, 0.96, 0.8>
		quick_color 1
  }
  normal
  {
    bumps 0.02
    scale 0.4
  }
  finish
  {
    ambient 0.0
    diffuse 0.15
    specular 1.7
    roughness 0.002
    reflection 
    {
      0.12, 0.8
      fresnel on
    }
  }
}

#declare TEX_ROOF =
texture
{
  pigment 
  {
    bumps
    color_map
    {
      [0.0 color rgb <0.65, 0.25, 0.08>]
      [1.0 color rgb <0.45, 0.35, 0.1>]
    }
    turbulence 0.2
    scale 0.4
  }
  normal
  {
    marble 0.3
    scale 0.2
  }
  
  finish
  {
    ambient 0.15
    diffuse 0.9
    specular 0.2
    roughness 0.2
  }
}

#declare TEX_WALL =
texture
{
  pigment 
  {
    bumps
    color_map
    {
      [0.0 color rgb <1.0, 0.85, 0.72>*0.80]
      [1.0 color rgb <1.0, 0.85, 0.72>]
    }
    scale 0.8
    quick_color 1
  }
  normal
  {
    granite 0.1
    scale 0.2
  }
  finish
  {
    ambient 0.15
    diffuse 0.8
    specular 0.2
    roughness 0.3
  }
}

#declare TEX_COLUMN =
texture
{
  pigment 
  {
    bumps
    color_map
    {
      [0.0 color rgb <1.0, 0.92, 0.77>*0.80]
      [1.0 color rgb <1.0, 0.92, 0.77>]
    }
    scale 0.8
    quick_color 1
  }
  normal
  {
    bumps 0.15
    scale 0.2
  }
  finish
  {
    ambient 0.1
    diffuse 0.8
    specular 0.3
    roughness 0.1
    reflection 0.3
  }
}

#declare TEX_DOOR =
texture
{
  pigment 
  {
    color rgb <0.8, 0.6, 0.4>
		quick_color 1
  }
  normal
  {
    bumps 0.2
    scale 0.9
  }
  finish
  {
    ambient 0.1
    diffuse 0.6
    specular 0.2
    roughness 0.2
  }
}

#declare O_WINDOW_FRAME=
difference
{
  box
  {
    <-0.05, 0, -0.5>
    < 0.05, 1,  0.5>
  }
  box
  {
    <-0.06, 0.1, -0.5+0.1>
    < 0.06, 1-0.1,  0.5-0.1>
  }
  texture 
  {
    TEX_DOOR
  }
}

#declare O_EMPTY_CUBE=
difference
{
  #local WALL = 0.3;
  box
  {
    <-5, -1.5, -5.5>
    < 5, 1.5,  5.5>
  }
  box
  {
    <-5+WALL, -1.6, -5.5+WALL>
    < 5-WALL, 1.5-WALL,  5.5-WALL>
  }
  translate <0, 1.5, 0>
}

#declare O_GLASS_CUBE=
difference
{
  box
  {
    <-5, -1.5, -5.5>
    < 5, 1.5,  5.5>
    scale <5.86/6.0, 1, 3.86/4.0>
  }
  box
  {
    <-5, -1.6, -5.5>
    < 5, 1.6,  5.5>
    scale <5.85/6.0, 1, 3.85/4.0>
  }
  translate <0, 1.5, 0>
  
  interior
  {
    ior 1.4
  }
}

#declare O_ROOF_BASE=
union
{
  intersection
  {
    box
    {
      <-5.5, -5.5, -5.5>
      < 5.5, 5.5, 5.5>
      rotate <-45, 0, 0>
    }
    
    box
    {
      <-15.5, 0, -15.5>
      <15.5, 7.3, 15.5>
    }
  }
  
  translate <-0.5, 0, 0>
  scale <1, 0.4, 1>
}

#declare O_ROOF_NO_GLASS=
difference
{
  object
  {
    O_ROOF_BASE
    scale <1.04, 0.75, 0.75>
    texture
    {
      TEX_ROOF
    }
  }

  object
  {
    O_ROOF_BASE
    scale <1, 0.707, 0.707>
    translate <-11, -0.0001, 0>
    texture
    {
      TEX_WALL
    }
  }
  object
  {
    O_ROOF_BASE
    scale <1, 0.707, 0.707>
    translate <10, -0.0001, 0>
    texture
    {
      TEX_WALL
    }
  }
}

#declare O_ROOF=
object
{
  O_ROOF_NO_GLASS
}

#declare O_STORY=
union
{
  // outer walls
  difference
  {
    object
    {
      O_EMPTY_CUBE
    }
    
    // Windows
    box
    {
      <-4.5, 0.8, -8>
      <-2.8, 2.1, 8>
    }
    
    box
    {
      <-1.9, 0.8, -8>
      <-0.8, 2.1, 8>
    }
    box
    {
      <2.8, 0.8, -8>
      <4.5, 2.1, 8>
    }

    // Staircase window
    box
    {
      <0, 1.1, -8>
      <0.9, 2.1, 8>
    }
    
    // Front
    box
    {
      <-8, 0.8, -3.3-0.3>
      <8, 2.1, -1.6-0.3>
    }

    box
    {
      <-8, 0.8, 1.6+0.3>
      <8, 2.1, 3.3+0.3>
    }
  }

  object
  {
    O_WINDOW_FRAME
    rotate <0, 90, 0>
    scale <1.7, 1.3, 1>
    translate <-7.3/2, 0.8, -5.35>  
  }

  object
  {
    O_WINDOW_FRAME
    rotate <0, 90, 0>
    scale <1.1, 1.3, 1>
    translate <-2.7/2, 0.8, -5.35>  
  }

  object
  {
    O_WINDOW_FRAME
    rotate <0, 90, 0>
    scale <1.7, 1.3, 1>
    translate <7.3/2, 0.8, -5.35>  
  }

  // Staircase window
  object
  {
    O_WINDOW_FRAME
    rotate <0, 90, 0>
    scale <0.9, 1.0, 1>
    translate <0.9/2, 1.1, -5.35>  
  }

  // Front

  object
  {
    O_WINDOW_FRAME
    scale <1, 1.3, 1.7>
    translate <-4.85, 0.8, -2.9>  
  }
  object
  {
    O_WINDOW_FRAME
    scale <1, 1.3, 1.7>
    translate <-4.85, 0.8, +2.9>  
  }
}


// The house
union
{
  // basement
  union
  {
  
    object
    {
      O_STORY
      scale <11/10, 1, 1>
      translate <-0.5, -3, 0>
    }
  
    // door step
    box
    {
      <-6.48, -0.38, -3>
      <-5, -0.19, 3>
    }
    box
    {
      <-6.96, -0.57, -3>
      <-5, -0.38, 3>
    }
   

    difference
    {
      union
      {
        object
        {
          O_STORY
        }
        object
        {
          O_GLASS_CUBE
          texture { TEX_GLASS }
        }
      }

      // entrance door      
      box
      {
        <-5.5, 0.0, -0.9>
        <-4.5, 2.2, 0.9>
      }
    }

    // door 
    difference
    {
      box
      {
        <-4.9, 0.0, -0.9>
        <-4.6, 2.2, 0.9>
      }
      box
      {
        <-4.99, 0.0, -0.8>
        <-4.8, 2.1, 0.8>
      }

      texture { TEX_DOOR }
    }

    // handle
    box
    {
      <-4.95, 1.1, 0.4>
      <-4.9, 1.15, 0.6>
      texture { TEX_COLUMN }
    }

    object
    {
      O_ROOF
      translate <0, 3.4, 0>
    }
    texture
    {
      TEX_WALL
    }
  }
	
  cone
  {
    <-5.5, -0.01, -5.0>, 0.32, <-5.5, 0.1, -5.0>, 0.26
    texture
    {
      TEX_COLUMN
    }
  }
  cone
  {
    <-5.5, -1, -5.0>, 0.25, <-5.5, 3.1, -5.0>, 0.22
    texture
    {
      TEX_COLUMN
    }
  }

  cone
  {
    <-5.5, -0.01, 5.0>, 0.32, <-5.5, 0.1, 5.0>, 0.26
    texture
    {
      TEX_COLUMN
    }
  }
  cone
  {
    <-5.5, -1, 5.0>, 0.25, <-5.5, 3.1, 5.0>, 0.22
    texture
    {
      TEX_COLUMN
    }
  }

  translate <-1, -0.09, 0>

  scale 0.3
}